"use strict";
import Antifurto from "../antifurto.js";
import Luci from "../luci.js";
import Scenari from "../scenari.js";
import Api from "./api.js";

class ApiMqttIn {

    static readAllRPCLuci = payloadJSON => {
        Api.sendDataLuciWeb(payloadJSON);
    }

    static luciReceived = [];
    static readStatusLuci = (outVal, payloadJSON) => {
        // TODO find true connection IN-OUT
        const index = ApiMqttIn.luciReceived.findIndex(luce => luce.out === outVal);
        if(index >= 0)//se ho gia' ricevuto la luce, non la conto
            return;
        const l = Luci.createLight(payloadJSON.luogo != null ? payloadJSON.luogo : 'test' + Date.now(), payloadJSON.stato, 'in' + ApiMqttIn.luciReceived.length, outVal);
        // add the light in the correct position in the lights array
        // the array should be sorted by out0, out1, out2, ... out7
        let i = 0;
        while (i < ApiMqttIn.luciReceived.length && ApiMqttIn.luciReceived[i].out < outVal) {
            i++;
        }
        if(i < ApiMqttIn.luciReceived.length)
            ApiMqttIn.luciReceived.splice(i, 0, l);
        else
            ApiMqttIn.luciReceived.push(l);

        if (ApiMqttIn.luciReceived.length >= 8) {
            const toBeSent = ApiMqttIn.luciReceived.splice(0, 8);
            Api.sendLuciWeb(toBeSent);
        }
    }

    static outForToggleLuciStato = null;//luce con "luce-out" = out0/.../out7
    /**
     *
     * @param {*} outVal out0/.../out7
     * @param {*} payloadJSON {event:true/false} luce accesa o spenta
     */
    static triggerLuce = (outVal, payloadJSON) => {
        if (Api.outForToggleLuciStato == null)
            return;
            // send to luci to figure out what is the connection
            // Api.sendLuciStatoWeb({ luce: ApiMqttIn.outForToggleLuciStato, nome: outVal, evento: payloadJSON.evento });
        if (ApiMqttIn.outForToggleLuciStato["luce-out"] === outVal && ApiMqttIn.outForToggleLuciStato.stato === payloadJSON.evento) {
            Api.sendLuciStatoWeb();
            ApiMqttIn.outForToggleLuciStato = null;
        }
    }

    static newLuce = payloadJSON => {
        Api.sendWebNewLuci(payloadJSON);
    }

    static readAllRPCScenari = payloadJSON => {
        if (payloadJSON.status != null){//escludo le luci
            console.log('ricevuto roba inutile',payloadJSON)
            return;
        }
        Api.sendScenariWeb(payloadJSON);
    }

    static cambioStatoScenario = payloadJSON => {
        Api.sendWebNewScenarioStatus(payloadJSON);
    }

    static readStatoAutomaScenario = stato => {
        Api.sendWebScenarioAutoma(stato);
    }

    static renamedSavedScenario = payloadJSON => {
        Api.sendWebSavedScenario(JSON.parse(payloadJSON));
    }

    static readAllRPCAntifurto = payloadJSON => {
        Api.sendWebGetAntifurto(payloadJSON);
    }

    static readNewStatoAntifurto = (stato,oldFrom = null) => {
        if(oldFrom == null){
            Api.sendWebSetAntifurtoStatus(stato);
            return;
        }
        switch(oldFrom){
            case 'scenari':{
                // se lo stato dell'antifurto è 0 (spento), lo stato degli scenari è 0 o 1 (antifurto spento)
                Scenari.correctlySetAntifurto(stato !== 0,true,true)
                break;
            }
            case 'antifurto':{
                // se lo stato degli scenari è 2 (antifurto acceso), lo stato dell'antifurto è 1 o 2 (antifurto acceso)
                Antifurto.activate(stato !== 2,true,true);
                break;
            }
        }
    }

}

export default ApiMqttIn;